//
//  HookUtility.m
//  RuntimeTest
//
//  Created by 吕中威 on 16/6/1.
//  Copyright © 2016年 吕中威. All rights reserved.
//

#import "HookUtility.h"
#import <objc/runtime.h>

@implementation HookUtility

+ (void)swizzlingInClass:(Class )cls originalSeletor :(SEL)originalSeletor  swizzledSelector :(SEL)swizzledSeletor{
    
    Class clazz = cls;
    Method orginalMethod = class_getInstanceMethod(clazz, originalSeletor);
    Method swizzledMethod = class_getInstanceMethod(clazz, swizzledSeletor);
    
    BOOL didAddMethod = class_addMethod(clazz, originalSeletor, method_getImplementation(swizzledMethod), method_getTypeEncoding(swizzledMethod));
    
    if(didAddMethod){
        
        class_replaceMethod(clazz, swizzledSeletor, method_getImplementation(orginalMethod), method_getTypeEncoding(orginalMethod));
    }else{
        
        method_exchangeImplementations(orginalMethod, swizzledMethod);
    }
}

@end
